/*
 *  LogChannel_ASCII.h
 */

#ifndef LOGCHANNEL_ASCII_H
#define LOGCHANNEL_ASCII_H

/*
 *  ASCII chars are defined in a number of different ways to make creating
 *  log channels as clear as possible.
 *
 *    ASCII_char:       ASCII byte in lower byte of 16bit word
 *    _char_:           ASCII byte in lower byte of 16bit word
 *    L_ASCII_char:     ASCII byte in lower byte of 16bit word
 *    U_ASCII_char:     ASCII byte in upper byte of 16bit word
 */

/* this is to shift 2 chars into a single word, not upper/lowercase! */
#define UPPER_SHIFT                         8

#define L_ASCII_NULL                        0x00
#define U_ASCII_NULL                        (0x00<<UPPER_SHIFT)
#define ASCII_NULL                          0x00
#define _NULL_                              0x00

#define ASCII_SPACE                         0x20
#define ASCII_BANG                          0x21
#define ASCII_DQUOTE                        0x22
#define ASCII_POUND                         0x23
#define ASCII_DOLLAR                        0x24
#define ASCII_PERCENT                       0x25
#define ASCII_AND                           0x26
#define ASCII_SQUOTE                        0x27
#define ASCII_OPAREN                        0x28
#define ASCII_CPAREN                        0x29
#define ASCII_ASTERISKS                     0x2a
#define ASCII_PLUS                          0x2b
#define ASCII_COMMA                         0x2c
#define ASCII_MINUS                         0x2d
#define ASCII_PERIOD                        0x2e
#define ASCII_DIVIDE                        0x2f

#define ASCII_0                             0x30
#define ASCII_1                             0x31
#define ASCII_2                             0x32
#define ASCII_3                             0x33
#define ASCII_4                             0x34
#define ASCII_5                             0x35
#define ASCII_6                             0x36
#define ASCII_7                             0x37
#define ASCII_8                             0x38
#define ASCII_9                             0x39
#define ASCII_A                             0x41
#define ASCII_B                             0x42
#define ASCII_C                             0x43
#define ASCII_D                             0x44
#define ASCII_E                             0x45
#define ASCII_F                             0x46
#define ASCII_G                             0x47
#define ASCII_H                             0x48
#define ASCII_I                             0x49
#define ASCII_J                             0x4a
#define ASCII_K                             0x4b
#define ASCII_L                             0x4c
#define ASCII_M                             0x4d
#define ASCII_N                             0x4e
#define ASCII_O                             0x4f
#define ASCII_P                             0x50
#define ASCII_Q                             0x51
#define ASCII_R                             0x52
#define ASCII_S                             0x53
#define ASCII_T                             0x54
#define ASCII_U                             0x55
#define ASCII_V                             0x56
#define ASCII_W                             0x57
#define ASCII_X                             0x58
#define ASCII_Y                             0x59
#define ASCII_Z                             0x5a
#define ASCII_a                             0x61
#define ASCII_b                             0x62
#define ASCII_c                             0x63
#define ASCII_d                             0x64
#define ASCII_e                             0x65
#define ASCII_f                             0x66
#define ASCII_g                             0x67
#define ASCII_h                             0x68
#define ASCII_i                             0x69
#define ASCII_j                             0x6a
#define ASCII_k                             0x6b
#define ASCII_l                             0x6c
#define ASCII_m                             0x6d
#define ASCII_n                             0x6e
#define ASCII_o                             0x6f
#define ASCII_p                             0x70
#define ASCII_q                             0x71
#define ASCII_r                             0x72
#define ASCII_s                             0x73
#define ASCII_t                             0x74
#define ASCII_u                             0x75
#define ASCII_v                             0x76
#define ASCII_w                             0x77
#define ASCII_x                             0x78
#define ASCII_y                             0x79
#define ASCII_z                             0x7a


#define _SPACE_                             ASCII_SPACE    
#define _BANG_                              ASCII_BANG     
#define _DQUOTE_                            ASCII_DQUOTE   
#define _POUND_                             ASCII_POUND    
#define _DOLLAR_                            ASCII_DOLLAR   
#define _PERCENT_                           ASCII_PERCENT  
#define _AND_                               ASCII_AND      
#define _SQUOTE_                            ASCII_SQUOTE   
#define _OPAREN_                            ASCII_OPAREN   
#define _CPAREN_                            ASCII_CPAREN   
#define _ASTERISKS_                         ASCII_ASTERISKS
#define _PLUS_                              ASCII_PLUS     
#define _COMMA_                             ASCII_COMMA    
#define _MINUS_                             ASCII_MINUS    
#define _PERIOD_                            ASCII_PERIOD   
#define _DIVIDE_                            ASCII_DIVIDE   

#define _0_                                 ASCII_0
#define _1_                                 ASCII_1
#define _2_                                 ASCII_2
#define _3_                                 ASCII_3
#define _4_                                 ASCII_4
#define _5_                                 ASCII_5
#define _6_                                 ASCII_6
#define _7_                                 ASCII_7
#define _8_                                 ASCII_8
#define _9_                                 ASCII_9
#define _A_                                 ASCII_A
#define _B_                                 ASCII_B
#define _C_                                 ASCII_C
#define _D_                                 ASCII_D
#define _E_                                 ASCII_E
#define _F_                                 ASCII_F
#define _G_                                 ASCII_G
#define _H_                                 ASCII_H
#define _I_                                 ASCII_I
#define _J_                                 ASCII_J
#define _K_                                 ASCII_K
#define _L_                                 ASCII_L
#define _M_                                 ASCII_M
#define _N_                                 ASCII_N
#define _O_                                 ASCII_O
#define _P_                                 ASCII_P
#define _Q_                                 ASCII_Q
#define _R_                                 ASCII_R
#define _S_                                 ASCII_S
#define _T_                                 ASCII_T
#define _U_                                 ASCII_U
#define _V_                                 ASCII_V
#define _W_                                 ASCII_W
#define _X_                                 ASCII_X
#define _Y_                                 ASCII_Y
#define _Z_                                 ASCII_Z
#define _a_                                 ASCII_a
#define _b_                                 ASCII_b
#define _c_                                 ASCII_c
#define _d_                                 ASCII_d
#define _e_                                 ASCII_e
#define _f_                                 ASCII_f
#define _g_                                 ASCII_g
#define _h_                                 ASCII_h
#define _i_                                 ASCII_i
#define _j_                                 ASCII_j
#define _k_                                 ASCII_k
#define _l_                                 ASCII_l
#define _m_                                 ASCII_m
#define _n_                                 ASCII_n
#define _o_                                 ASCII_o
#define _p_                                 ASCII_p
#define _q_                                 ASCII_q
#define _r_                                 ASCII_r
#define _s_                                 ASCII_s
#define _t_                                 ASCII_t
#define _u_                                 ASCII_u
#define _v_                                 ASCII_v
#define _w_                                 ASCII_w
#define _x_                                 ASCII_x
#define _y_                                 ASCII_y
#define _z_                                 ASCII_z

#define L_ASCII_0                           0x30
#define L_ASCII_1                           0x31
#define L_ASCII_2                           0x32
#define L_ASCII_3                           0x33
#define L_ASCII_4                           0x34
#define L_ASCII_5                           0x35
#define L_ASCII_6                           0x36
#define L_ASCII_7                           0x37
#define L_ASCII_8                           0x38
#define L_ASCII_9                           0x39
#define L_ASCII_A                           0x41
#define L_ASCII_B                           0x42
#define L_ASCII_C                           0x43
#define L_ASCII_D                           0x44
#define L_ASCII_E                           0x45
#define L_ASCII_F                           0x46
#define L_ASCII_G                           0x47
#define L_ASCII_H                           0x48
#define L_ASCII_I                           0x49
#define L_ASCII_J                           0x4a
#define L_ASCII_K                           0x4b
#define L_ASCII_L                           0x4c
#define L_ASCII_M                           0x4d
#define L_ASCII_N                           0x4e
#define L_ASCII_O                           0x4f
#define L_ASCII_P                           0x50
#define L_ASCII_Q                           0x51
#define L_ASCII_R                           0x52
#define L_ASCII_S                           0x53
#define L_ASCII_T                           0x54
#define L_ASCII_U                           0x55
#define L_ASCII_V                           0x56
#define L_ASCII_W                           0x57
#define L_ASCII_X                           0x58
#define L_ASCII_Y                           0x59
#define L_ASCII_Z                           0x5a
#define L_ASCII_a                           0x61
#define L_ASCII_b                           0x62
#define L_ASCII_c                           0x63
#define L_ASCII_d                           0x64
#define L_ASCII_e                           0x65
#define L_ASCII_f                           0x66
#define L_ASCII_g                           0x67
#define L_ASCII_h                           0x68
#define L_ASCII_i                           0x69
#define L_ASCII_j                           0x6a
#define L_ASCII_k                           0x6b
#define L_ASCII_l                           0x6c
#define L_ASCII_m                           0x6d
#define L_ASCII_n                           0x6e
#define L_ASCII_o                           0x6f
#define L_ASCII_p                           0x70
#define L_ASCII_q                           0x71
#define L_ASCII_r                           0x72
#define L_ASCII_s                           0x73
#define L_ASCII_t                           0x74
#define L_ASCII_u                           0x75
#define L_ASCII_v                           0x76
#define L_ASCII_w                           0x77
#define L_ASCII_x                           0x78
#define L_ASCII_y                           0x79
#define L_ASCII_z                           0x7a

#define U_ASCII_0                           (L_ASCII_0<<UPPER_SHIFT)
#define U_ASCII_1                           (L_ASCII_1<<UPPER_SHIFT)
#define U_ASCII_2                           (L_ASCII_2<<UPPER_SHIFT)
#define U_ASCII_3                           (L_ASCII_3<<UPPER_SHIFT)
#define U_ASCII_4                           (L_ASCII_4<<UPPER_SHIFT)
#define U_ASCII_5                           (L_ASCII_5<<UPPER_SHIFT)
#define U_ASCII_6                           (L_ASCII_6<<UPPER_SHIFT)
#define U_ASCII_7                           (L_ASCII_7<<UPPER_SHIFT)
#define U_ASCII_8                           (L_ASCII_8<<UPPER_SHIFT)
#define U_ASCII_9                           (L_ASCII_9<<UPPER_SHIFT)
#define U_ASCII_A                           (L_ASCII_A<<UPPER_SHIFT)
#define U_ASCII_B                           (L_ASCII_B<<UPPER_SHIFT)
#define U_ASCII_C                           (L_ASCII_C<<UPPER_SHIFT)
#define U_ASCII_D                           (L_ASCII_D<<UPPER_SHIFT)
#define U_ASCII_E                           (L_ASCII_E<<UPPER_SHIFT)
#define U_ASCII_F                           (L_ASCII_F<<UPPER_SHIFT)
#define U_ASCII_G                           (L_ASCII_G<<UPPER_SHIFT)
#define U_ASCII_H                           (L_ASCII_H<<UPPER_SHIFT)
#define U_ASCII_I                           (L_ASCII_I<<UPPER_SHIFT)
#define U_ASCII_J                           (L_ASCII_J<<UPPER_SHIFT)
#define U_ASCII_K                           (L_ASCII_K<<UPPER_SHIFT)
#define U_ASCII_L                           (L_ASCII_L<<UPPER_SHIFT)
#define U_ASCII_M                           (L_ASCII_M<<UPPER_SHIFT)
#define U_ASCII_N                           (L_ASCII_N<<UPPER_SHIFT)
#define U_ASCII_O                           (L_ASCII_O<<UPPER_SHIFT)
#define U_ASCII_P                           (L_ASCII_P<<UPPER_SHIFT)
#define U_ASCII_Q                           (L_ASCII_Q<<UPPER_SHIFT)
#define U_ASCII_R                           (L_ASCII_R<<UPPER_SHIFT)
#define U_ASCII_S                           (L_ASCII_S<<UPPER_SHIFT)
#define U_ASCII_T                           (L_ASCII_T<<UPPER_SHIFT)
#define U_ASCII_U                           (L_ASCII_U<<UPPER_SHIFT)
#define U_ASCII_V                           (L_ASCII_V<<UPPER_SHIFT)
#define U_ASCII_W                           (L_ASCII_W<<UPPER_SHIFT)
#define U_ASCII_X                           (L_ASCII_X<<UPPER_SHIFT)
#define U_ASCII_Y                           (L_ASCII_Y<<UPPER_SHIFT)
#define U_ASCII_Z                           (L_ASCII_Z<<UPPER_SHIFT)
#define U_ASCII_a                           (L_ASCII_a<<UPPER_SHIFT)
#define U_ASCII_b                           (L_ASCII_b<<UPPER_SHIFT)
#define U_ASCII_c                           (L_ASCII_c<<UPPER_SHIFT)
#define U_ASCII_d                           (L_ASCII_d<<UPPER_SHIFT)
#define U_ASCII_e                           (L_ASCII_e<<UPPER_SHIFT)
#define U_ASCII_f                           (L_ASCII_f<<UPPER_SHIFT)
#define U_ASCII_g                           (L_ASCII_g<<UPPER_SHIFT)
#define U_ASCII_h                           (L_ASCII_h<<UPPER_SHIFT)
#define U_ASCII_i                           (L_ASCII_i<<UPPER_SHIFT)
#define U_ASCII_j                           (L_ASCII_j<<UPPER_SHIFT)
#define U_ASCII_k                           (L_ASCII_k<<UPPER_SHIFT)
#define U_ASCII_l                           (L_ASCII_l<<UPPER_SHIFT)
#define U_ASCII_m                           (L_ASCII_m<<UPPER_SHIFT)
#define U_ASCII_n                           (L_ASCII_n<<UPPER_SHIFT)
#define U_ASCII_o                           (L_ASCII_o<<UPPER_SHIFT)
#define U_ASCII_p                           (L_ASCII_p<<UPPER_SHIFT)
#define U_ASCII_q                           (L_ASCII_q<<UPPER_SHIFT)
#define U_ASCII_r                           (L_ASCII_r<<UPPER_SHIFT)
#define U_ASCII_s                           (L_ASCII_s<<UPPER_SHIFT)
#define U_ASCII_t                           (L_ASCII_t<<UPPER_SHIFT)
#define U_ASCII_u                           (L_ASCII_u<<UPPER_SHIFT)
#define U_ASCII_v                           (L_ASCII_v<<UPPER_SHIFT)
#define U_ASCII_w                           (L_ASCII_w<<UPPER_SHIFT)
#define U_ASCII_x                           (L_ASCII_x<<UPPER_SHIFT)
#define U_ASCII_y                           (L_ASCII_y<<UPPER_SHIFT)
#define U_ASCII_z                           (L_ASCII_z<<UPPER_SHIFT)
                                            
#endif /* LOGCHANNEL_ASCII_H */             
                                            
                                            
                                            
                                            
                                            
                                            
                                            
                                            