/***************************************************************************
 *             
 *   This file contains Analog Devices, Inc. proprietary information.
 *   Copyright 2001 by Analog Devices, Inc.  All rights reserved.
 *
 *    File           : def218x.h
 *    Project        : Forge
 *    Author(s)      : RBaig
 *    Started        : 28 March, 2002
 *    Description    : ADSP218x constants & macros header file, DSP TAC developer 
 *                     can modify this file to add memory map address of all
 *                     other registers in AD20msp430 chipset.
 *
 *    Revision Control system (RCS) Information:
 *
 *    $Workfile:   def218x.h  $
 *    $Revision:   1.0  $
 *     $Modtime:   Jul 03 2004 17:49:32  $
 *        $Date:   Jul 15 2004 14:45:14  $
 *      $Author:   RBaig  $
 *     $Archive:   X:/Archive/Tools/Forge/Software/Target_Software/DSP/Library/TIC_DRV/218x/inc/def218x.h-arc  $
 *  
 ***************************************************************************/

/*
#ifndef DSPDEF_H
   DSPDEF_H
*/
/*
 * constant definitions
 */
#define DIS_AR_SAT 0xFFF7  /* clear bit 3 */
#define ENA_AR_SAT 0x0008  /* set bit 3 */

/* register address */
#define   SYS_CNTL_REG        0x3FFF   /* address of system control register */ 
#define   DWAIT               0x3FFE   /* address of DWAIT register */

#define   SPORT0_CNTL_REG     0x3FF6   /* address of sport0 control register */
#define   SPORT1_CNTL_REG     0x3FF2   /* address of sport1 control register */

#define   SPORT0_AUTOBUF_REG  0x3FF3   /* address of sport0 autobuffering 
										* control register 
										*/
#define   SPORT1_AUTOBUF_REG  0x3FEF   /* address of sport1 autobuffering 
										* control register 
										*/
#define   DSP_PRI_CFG_REG     0x001C  /* High Priority Configuration Reg */

#define   ENA_INT_NESTING     0x10     /* bit to be set to enable int nesting */
#define   ENA_IRQ2_INT        0x0200   /* bit to be set to enable IRQ2 int */
#define   ENA_SPORT0          0x1000   /* bit to Enable SPORT 0 */
#define   ENA_SPORT1          0x0C00   /* bit to Enable SPORT 1 */

#define   ENA_SPORT0_TX_INT   0x0040   /* bit to be set to enable SPORT0 TX int */
#define   ENA_SPORT0_RX_INT   0x0020   /* bit to be set to enable SPORT0 RX int */

#define   ENA_SPORT1_TX_INT   0x0004   /* bit to be set to enable SPORT1 TX int */
#define   ENA_SPORT1_RX_INT   0x0002   /* bit to be set to enable SPORT1 RX int */

#define   DIS_INT_NESTING     0x0F     /* bit to be clear to disable int nesting */
#define   DIS_IRQ2_INT        0xFDFF   /* mask to clear bit, to disable IRQ2 int */
#define   DIS_SPORT0          0xEFFF   /* mask bit12 to disable SPORT 0 */
#define   DIS_SPORT1          0xF7FF   /* mask bit11 to disable SPORT 1 */

#define   DIS_SPORT0_TX_INT   0xFFBF   /* mask to clear bit, to disable SPORT0 TX int */
#define   DIS_SPORT0_RX_INT   0xFFDF   /* mask to clear bit, to disable SPORT0 RX int */

#define   DIS_SPORT1_TX_INT   0xFFFB   /* mask to clear bit, to disable SPORT1 TX int */
#define   DIS_SPORT1_RX_INT   0xFFFD   /* mask to clear bit, to disable SPORT1 RX int */

/* DSP interrupt controller register map */
#define   DSPINT_BASE_ADDR    0x0400 
#define   DSPINT_XBAR_CFGREG  (DSPINT_BASE_ADDR + 0x0000)
#define   DSPINT_AIREG        (DSPINT_BASE_ADDR + 0x0080)
#define   DSPINT_CIREG        (DSPINT_BASE_ADDR + 0x00C0)
#define   DSPINT_HWMASKREG    (DSPINT_BASE_ADDR + 0x0100)
#define   DSPINT_HWSTSREG     (DSPINT_BASE_ADDR + 0x0140)
#define   DSPINT_SWI_MASKREG  (DSPINT_BASE_ADDR + 0x0180)
#define   DSPINT_SWI_STSREG   (DSPINT_BASE_ADDR + 0x01C0)
#define   DSPINT_XASSERTREG   (DSPINT_BASE_ADDR + 0x0300)

/* DSP interrupt controller RAU modes */
#define   DSPINT_RAU00        0x0000
#define   DSPINT_RAU01        0x0010
#define   DSPINT_RAU10        0x0020
#define   DSPINT_RAU11        0x0030

/* for debugging only */
#define   PFDATA              0x3FE5
#define   PFTYPE              0x3FE6

/* DSP Page registers */
#define   RWSM_DM_page00           0x0000
#define   RWSM_DM_page01           0x0001
#define   RWSM_DM_page10           0x0002
#define   RWSM_DM_page11           0x0003
#define   RWSM_DM_page20           0x0004
#define   RWSM_DM_page21           0x0005
#define   RWSM_DM_page30           0x0006
#define   RWSM_DM_page31           0x0007
#define   RWSM_DM_page40           0x0008
#define   RWSM_DM_page41           0x0009
#define   RWSM_DM_page50           0x000A
#define   RWSM_DM_page51           0x000B

#define   RWSM_DM_page0_ID         0x2
#define   RWSM_DM_page1_ID         0x3
#define   RWSM_DM_page2_ID         0x4
#define   RWSM_DM_page3_ID         0x5
#define   RWSM_DM_page4_ID         0x6
#define   RWSM_DM_page5_ID         0x7

#define   RWSM_PM_page00           0x000C
#define   RWSM_PM_page01           0x000D
#define   RWSM_PM_page10           0x000E
#define   RWSM_PM_page11           0x000F
#define   RWSM_PM_page20           0x0010
#define   RWSM_PM_page21           0x0011
#define   RWSM_PM_page30           0x0012
#define   RWSM_PM_page31           0x0013
#define   RWSM_PM_page40           0x0014
#define   RWSM_PM_page41           0x0015
#define   RWSM_PM_page50           0x0016
#define   RWSM_PM_page51           0x0017
#define   RWSM_PM_page60           0x0018
#define   RWSM_PM_page61           0x0019
#define   RWSM_PM_page70           0x001A
#define   RWSM_PM_page71           0x001B

#define   RWSM_PM_page0_ID         0x0
#define   RWSM_PM_page1_ID         0x1
#define   RWSM_PM_page2_ID         0x2
#define   RWSM_PM_page3_ID         0x3
#define   RWSM_PM_page4_ID         0x4
#define   RWSM_PM_page5_ID         0x5
#define   RWSM_PM_page6_ID         0x6
#define   RWSM_PM_page7_ID         0x7

#define   DSP_PAGE_SIZE_WORDS 0x400
#define   DSP_PAGE_SIZE_BYTES 0x800

/*#endif DSPDEF_H */