/***************************************************************************
 *             
 *   This file contains Analog Devices, Inc. proprietary information.
 *   Copyright 2001 by Analog Devices, Inc.  All rights reserved.
 *
 *    File           : TVCPEXT.h
 *    Project        : Forge Target Virtual Communication Port (TVCP)
 *    Author(s)      : Baig, Raheem
 *    Started        : Oct 02 2001
 *    Description    : Contains TVCP declarations those are useful in other files.
 *
 *    Revision Control system (RCS) Information:
 *
 *    $Workfile:   tvcpext.h  $
 *    $Revision:   1.0  $
 *     $Modtime:   Apr 02 2003 05:58:26  $   
 *        $Date:   Jul 15 2004 14:57:56  $   
 *      $Author:   RBaig  $   
 *     $Archive:   X:/Archive/Tools/Forge/Software/Target_Software/MCU/Target/Code/inc/tvcpext.h-arc  $   
 *  
 ***************************************************************************/

#ifndef TVCPEXT_H
   #define TVCPEXT_H


/*****************************************************************************
 * Global Declarations
 ****************************************************************************/
#define VCP_HDR_NUM_BYTES  2
typedef UINT16  VCP_TRLR; 

#define VCP_ID_NOT_ASSIGNED         0x00   /* default value of Self Id, before 
                                            the Id assigned */


/*****************************************************************************

          Name:   VCP_HDR

          Type:   structure

Scope Of Usage:   
                  
   Description:   useful in defining variables for VCP header

*****************************************************************************/
typedef struct tagVCP_HDR
{
   UINT8 vcpHdr[VCP_HDR_NUM_BYTES];
}VCP_HDR;

#endif
