.MODULE  m_CSR;


#include "C:\Program Files\Analog Devices Inc\Forge\Target_Software\DSP\Library\TIC_DRV\218x\inc\SDO.h"

#define COS_STACK_LWM_VALUE                 0x5555
#define COS_STACK_HWM_VALUE                 0xeeee

#define STACK_LEN_DM1                       200

#define LEN_CONTEXT                         10

.VAR    Context1[LEN_CONTEXT];
.GLOBAL Context1;
.VAR    Context2[LEN_CONTEXT];
.GLOBAL Context2;
.VAR    Context3[LEN_CONTEXT];
.GLOBAL Context3;
.VAR    Context4[LEN_CONTEXT];
.GLOBAL Context4;

.VAR    CosStackPtr, CosStackLowWaterMark, CosStack[STACK_LEN_DM1], CosStackHighWaterMark;
.GLOBAL CosStackPtr, CosStackLowWaterMark, CosStack,                CosStackHighWaterMark;

.VAR    testcntr;

.GLOBAL dlddicEndRecallStacks, dlddicEndSaveStacks;

.EXTERNAL dicSaveStacks, dicRecallStacks;
.EXTERNAL ProgforPop_h, ProgforPop_l, ProgforPush_h, ProgforPush_l;


.entry  CSRInit, CSRTest;


CSRInit:
    /* basic processor initializations */
    DMOVLAY = 0x0001;
    PMOVLAY = 0x0000;

    IFC = 0x00ff;
    ICNTL = 0x0000;
    IMASK = 0x0000;

    AR = 0x1249;
    DM(0x3ffe) = AR;

    AR = 0xe001;
    DM(0x3fff) = AR;

    AR = 0x001b;
    DM(0x001c) = AR;

    AR = 5;
    DM(0x00a9) = AR;
  
    /* init Context arrays */
    
    AR = 0x1000;
    I0 = ^Context1;
    L0 = 0;
    M1 = 1;
    CNTR = LEN_CONTEXT;
    do CF1 until CE;
      DM(I0, M1) = AR;
CF1:  AR = AR + 1;

    AR = 0x2000;
    I0 = ^Context2;
    CNTR = LEN_CONTEXT;
    do CF2 until CE;
      DM(I0, M1) = AR;
CF2:  AR = AR + 1;

    AR = 0x3000;
    I0 = ^Context3;
    CNTR = LEN_CONTEXT;
    do CF3 until CE;
      DM(I0, M1) = AR;
CF3:  AR = AR + 1;

    AR = 0x4000;
    I0 = ^Context4;
    CNTR = LEN_CONTEXT;
    do CF4 until CE;
      DM(I0, M1) = AR;
CF4:  AR = AR + 1;

    AR = ^CosStack;
    DM(CosStackPtr) = AR;
    AR = COS_STACK_LWM_VALUE;
    DM(CosStackLowWaterMark) = AR;
    AR = COS_STACK_HWM_VALUE;
    DM(CosStackHighWaterMark) = AR;

    /* write loopstackil/h opcodes for ax0 */
 
    /* ax0 = toploopstackih */
    i4 = ^ProgforPop_h;
    l4 = 0;
    m4 = 0;
    ar = 0x0D02; px = 0x0c;
    pm(i4,m4) = ar;
    /* ax0 = toploopstackil */
    i4 = ^ProgforPop_l;
    ar = 0x0D02; px = 0x0d;
    pm(i4,m4) = ar;

    /* toploopstackih = ax0 */
    i4 = ^ProgforPush_h;
    ar = 0x0D08; px = 0xc0;
    pm(i4,m4) = ar;
    /* toploopstackil = ax0 */
    i4 = ^ProgforPush_l;
    ar = 0x0D08; px = 0xd0;
    pm(i4,m4) = ar;
    
    I4 = DM(CosStackPtr);
    L4 = 0;
    M7 = 1;

    AR = 0x0000;
    DM(testcntr) = AR;
    
    rts;
    
CSRTest:
/*
 *  test case 1:  enter a loop, save and restore stacks
 */

    !CNTR = 30;
    !do T4 until CE;
      !CNTR = 31;
      !do T3 until CE;
        !CNTR = 32;
        !do T2 until CE;
          CNTR = 33;
          do T1 until CE;
            AR = DM(0x3fe9);
            AR = tstbit 1 of AR;
            if NE jump EndOfLoopStackOverflow;
            nop;
            M4 = 1;
            jump dicSaveStacks;
dlddicEndSaveStacks:
            nop;
            
            call NewLoopTest;
            AR = SSTAT;
            call SDO_WriteValue_;
            
            call NewLoopTest;

            call IncTestCNTR;
            call SDO_WriteValue_;
            call Delay;

            AR = SSTAT;
            call SDO_WriteValue_;
            
            M4 = -1;
            modify (i4,m4);
            jump dicRecallStacks;
dlddicEndRecallStacks:

            !AR = DM(testcntr);

            m4 = 1;
            modify(i4, m4);
            nop;      
T1:         nop;
T2:       nop;
T3:     nop;
T4:   nop;

    rts;

NewLoopTest:
#if 1
    CNTR = 0x0040;
    do N4 until CE;
      CNTR = 0x0030;
      do N3 until CE;
        CNTR = 0x0020;
        do N2 until CE;
          CNTR = 0x0050;
          do N1 until CE;
            nop;
N1:         nop;
N2:       nop;
N3:     nop;
N4:   nop;

    rts;

#endif

Delay:
#ifndef DSP_SIMULATION
    AR = 0x7fff;
loop1:
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop;
    AR = AR - 1;
    if NE jump loop1;
#endif

    rts;

IncTestCNTR:
    AR = DM(testcntr);
    AR = AR + 1;
    DM(testcntr) = AR;

    rts;

EndOfLoopStackOverflow:
    AR = 0xaaaa;
    call SDO_WriteValue_;
w1:
    jump w1;

.ENDMOD;

