/*
 *  HSL driver for MSP430
 */

.MODULE m_HSLDrv;

#include    "C:\dspdev\hsl\log API\sw - 218x\HSL TAC 1\Code\inc\HSLDrv.h"
#include    "C:\dspdev\hsl\log API\sw - 218x\HSL TAC 1\Code\inc\NopUtil.h"

.ENTRY      InitHSL;


InitHSL:
   AX0 = 0;
   HSL_WRITE_CFG(AX0);

   AX0 = 0xffff;
   HSL_WRITE_MASK(0, AX0);
   HSL_WRITE_MASK(1, AX0);
   HSL_WRITE_MASK(2, AX0);
   HSL_WRITE_MASK(3, AX0);

   !AX0 = HSL_DIV_RATIO;
   AX0 = HSL_CFG_DIV_4;
   HSL_WRITE_CFG(AX0);

   /* wait 2 hsl clocks for hsl block internal states to settle before enabling port
    * max is 16 cycles */
   !CALL nop16;
   LOOPNOP(16);
   /* re-enable the port */
   CALL enableHslPort;
/*
 * wait for port to start up & bandsaw to recover from period without clocks
 * max is 241 cycles at 65 MHz
 */
   !CALL nop250;
   LOOPNOP(250);
   /* enable the address trace*/
/*   CALL enableAddressTrace;*/
    nop; nop; nop; nop;
    nop; nop; nop; nop;

/* 0111-14211  spurious flash read at 0x1000000 .. 0x10fffff by DSP affected
 * clients application NVram code.
 * Added this enable call to start logging during boot for better visibility.
 */

   CALL enableLogger;

   RTS;

enableHslPort:
   AY0 = HSL_CFG_PORT_EN;
   JUMP hslCfgSetBit;
   
disableHslPort:
   AY0 = HSL_CFG_PORT_EN;
   JUMP hslCfgClrBit;

enableLogger:
   AY0 = HSL_CFG_LOGGING_EN;
   JUMP hslCfgSetBit;
   
disableLogger:
   AY0 = HSL_CFG_LOGGING_EN;
   JUMP hslCfgClrBit;

/*
 *  hsl config register set and clear bit operations - local functions
 */

hslCfgSetBit:
   HSL_READ_CFG(AR);
   AR = AR OR AY0;
   JUMP hslWriteCfgReg;

hslCfgClrBit:
   AR = AY0;              /* invert the bit mask */
   AR = not AR ;
   AY0 = AR;
   HSL_READ_CFG(AR);     /* AND ~mask with cfg reg contents */
   AR = AR AND AY0;

hslWriteCfgReg:
   HSL_WRITE_CFG(AR);
   RTS;


.ENDMOD;
