/***************************************************************************
 *             
 *   This file contains Analog Devices, Inc. proprietary information.
 *   Copyright 2001 by Analog Devices, Inc.  All rights reserved.
 *
 *    File           : tic_hdr.dsp
 *    Project        : Forge
 *    Author(s)      : RBaig
 *    Started        : 28 March 2002
 *    Description    : Interrupt Vector table header file. This file can be
 *                     modified by DSP TAC developer to add any ISR routine
 *                     used for DSP TAC.
 *                     File should not be modified to remove the following
 *                     ISRs in interrupt vector table:
 *                     1. main_
 *                     2. TicSwiIsr_
 *
 *    Revision Control system (RCS) Information:
 *
 *    $Workfile:$
 *    $Revision:$
 *     $Modtime:$
 *        $Date:$
 *      $Author:$
 *     $Archive:$
 *  
 ***************************************************************************/


.MODULE/RAM/SEG=vectors/ABS=0   __218x_Runtime_Header_;

/*
 * includes
 */
#include "tic_drv.h"        /* Forge DSP TIC drivers header file */
#include "DIC.h"            /* DSP Interrupt Controller driver header file */

/*
 * DSP Target Inter-processor Communication (TIC) Runtime Header
 *
 */

/*
 * Variables and Externals
*/

/*
 * Entries
 */

/*
 * Interrupt Vector Table, address PM(0x0000)
 */
        nop;call main_;nop;nop;        /* RESET VECTOR */
        JUMP DIC_IRQ2Isr_;nop;nop;nop; /* IRQ2 */
        rti;nop;nop;nop;               /* IRQL1 */
        rti;nop;nop;nop;               /* IRQL0 */
        rti;nop;nop;nop;               /* SPORT0 TX */
        rti;nop;nop;nop;               /* SPORT0 RX */
        rti;nop;nop;nop;               /* IRQE */
        rti;nop;nop;nop;               /* BDMA */
        rti;nop;nop;nop;               /* SPORT1 TX or IRQ1 */
        rti;nop;nop;nop;               /* SPORT1 RX or IRQ0 */
        rti;nop;nop;nop;               /* Timer */
        idle;rti;nop;nop;              /* Powerdown (non-maskable) */

.ENDMOD;
/*
 ***************************************************************************
 */

